/***************************************************************************
* aabb.h         Axis-Aligned Bounding Box                                 *
*                                                                          *
* AABB is a simple structure that defines a three-dimensional box.         *
* This header defines numerous convenient operations on these 3D boxes     *
* such as those that translate or expand the box.                          *
*                                                                          *
*                                                                          *
***************************************************************************/
#ifndef __AABB_INCLUDED__
#define __AABB_INCLUDED__

#include "interval.h"
#include "vec3.h"

struct AABB // A box in R3.  Useful for bounding boxes.
{
    struct Interval X;
    struct Interval Y;
    struct Interval Z;
};

double SurfaceArea( struct AABB A );
bool aabbIsNull( struct AABB A );
bool aabbExpand( struct AABB *a, struct AABB b );

#endif
