/***************************************************************************
* color.h                                                                  *
*                                                                          *
* Color is a trivial encapsulation of floating-point RGB colors.  It has   *
* the obvious operators defined as inline functions.  Note that there is   *
* no subtraction operator for colors, and that multiplication is performed *
* component-wise and results in another color.                             *
*                                                                          *
*                                                                          *
***************************************************************************/
#ifndef __COLOR_INCLUDED__
#define __COLOR_INCLUDED__

struct Color 
{
    double red;
    double green;
    double blue;
};

void colorSet( struct Color *c, double r, double g, double b );

struct Color colorAdd( struct Color A, struct Color B );
struct Color color_mul_color( struct Color A, struct Color B );
struct Color scalar_mul_color( double d, struct Color A );

#endif
