/***************************************************************************
* Interval.h                                                               *
*                                                                          *
* The Interval class defines a closed interval on the real line, defined   *
* a minimum and a maximum value.  Numerous basic operations are defined    *
* for intervals, such as expanding them to include a value or another      *
* interval.  Intervals are convenient for defining rectangles (such as the *
* view window) and boxes (such as axis-aligned bounding boxes).            *
*                                                                          *
***************************************************************************/
#ifndef __INTERVAL_INCLUDED__
#define __INTERVAL_INCLUDED__

struct Interval 
{ // An interval of real numbers.
    double min;
    double max;
};

typedef enum {false=0, true} bool; 

double Len( struct Interval I );
struct Interval intervalDiv( struct Interval I, double c );
bool intervalIsNull( struct Interval I );

#endif
