#include "util.h"

extern struct Interval block_GetSlab( struct Object *obj, struct Vec3 *v );
extern struct Interval sphere_GetSlab( struct Object *obj, struct Vec3 *v );
extern struct Interval triangle_GetSlab( struct Object *obj, struct Vec3 *v );
extern struct Interval point_GetSlab( struct Object *obj, struct Vec3 *v );

struct AABB GetBox( struct Object *obj )
{
    struct AABB box;
	struct Vec3 vec3x, vec3y, vec3z;

	vec3x.x = 1; vec3x.y = 0; vec3x.z = 0;
	vec3y.x = 0; vec3y.y = 1; vec3y.z = 0;
	vec3z.x = 0; vec3z.y = 0; vec3z.z = 1;

	if(strcmp(obj->name, "block") == 0)
	{
		box.X = block_GetSlab( obj, &vec3x );
		box.Y = block_GetSlab( obj, &vec3y );
		box.Z = block_GetSlab( obj, &vec3z );
	}
	else if(strcmp(obj->name, "sphere") == 0)
	{
		box.X = sphere_GetSlab( obj, &vec3x );
		box.Y = sphere_GetSlab( obj, &vec3y );
		box.Z = sphere_GetSlab( obj, &vec3z );
	}
	else if(strcmp(obj->name, "triangle") == 0)
	{
		box.X = triangle_GetSlab( obj, &vec3x );
		box.Y = triangle_GetSlab( obj, &vec3y );
		box.Z = triangle_GetSlab( obj, &vec3z );
	}
	else if(strcmp(obj->name, "point") == 0)
	{
		box.X = point_GetSlab( obj, &vec3x );
		box.Y = point_GetSlab( obj, &vec3y );
		box.Z = point_GetSlab( obj, &vec3z );
	}


    return box;
}

double min( double x, double y )
{
	return x <= y ? x : y;
}

double max( double x, double y )
{
    return x >= y ? x : y;
}

double min3( double x, double y, double z )
{
    if( x <= y && x <= z ) return x;
    if( y <= z ) return y;
    return z;
}

double max3( double x, double y, double z )
{
    if( x >= y && x >= z ) return x;
    if( y >= z ) return y;
    return z;
}
