/***************************************************************************
* vec3.h                                                                   *
*                                                                          *
* Vec3 is a trivial encapsulation of 3D floating-point coordinates.        *
* It has all of the obvious operators defined as inline functions.         *
*                                                                          *
***************************************************************************/
#ifndef __VEC3_INCLUDED__
#define __VEC3_INCLUDED__

struct Vec3 
{
    double x;
    double y;
    double z;
};

void vec3Set( struct Vec3 *v, double x, double y, double z );

double LengthSquared( struct Vec3 A );

struct Vec3 vec3Minus( struct Vec3 A );
struct Vec3 vec3Add( struct Vec3 A, struct Vec3 B );
struct Vec3 vec3Sub( struct Vec3 A, struct Vec3 B );
struct Vec3 vec3Mul( double a, struct Vec3 A );
struct Vec3 vec3Div( struct Vec3 A, double c );

struct Vec3 Unit( struct Vec3 A );

double vec3InnerProduct( struct Vec3 A, struct Vec3 B );  // Inner product.

struct Vec3 vec3CrossProduct( struct Vec3 A, struct Vec3 B ); // Cross product.

struct Vec3 vec3RCP( struct Vec3 A, struct Vec3 B );  // Remove component parallel to B.

double Length( struct Vec3 A );
double dist( struct Vec3 A, struct Vec3 B ); // Euclidean distance from A to B.

#endif
