#include <fcntl.h> 
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>

#define MAX_PATH_LEN 200
#define STRINGIFY(x) #x
#define EXPAND(x) STRINGIFY(x)

void *TheGnuPlotter;


/*
 * This is a dummy function and intensionally blank.
 */
void *create_TheGnuPlotter()
{
  return (0);
}

/*
 * Get a pointer to a string of a path to where explicitly
 * maintained temporary files can go. Do not free the 
 * array after use.
 */
char *tmpDir()
{
  char cwd[ MAX_PATH_LEN];
  char *env;
  env = getenv ( "TMPDIR");
  if( env == NULL) {
    env = getcwd( cwd, MAX_PATH_LEN);
  }
  return( env);
}

extern char *getTempFile( char* fname)
{
  char *tmp;
  char *path;
  tmp = tmpDir();
  path = tempnam( tmp, fname); 
  return( path);
}



extern void launchGnuPlot( char* scriptName)
{
  char *cmd = EXPAND(GNUPLOT_PATH)" ";
  char oldDir[ MAX_PATH_LEN];
  char commandLine[ sizeof( cmd) + FILENAME_MAX];

  strncpy( commandLine, cmd, sizeof( commandLine));
  strncat( commandLine, scriptName, sizeof( commandLine) - strlen( commandLine) - 1);
  getcwd( oldDir, MAX_PATH_LEN); 
  chdir( tmpDir());
  system( commandLine);
  chdir( oldDir);
}

extern 
void launchBarScriptFormat( char* input, char *output, char* format) {
    char *sac = getenv("SACBASE");
    char *script = "/stdlib/world/stdio/gnuplot/src/GnuPlotUnibench/bargraph.pl ";
    char *cmd;
    char oldDir[ MAX_PATH_LEN];


    int len = strlen(sac) + strlen(script) + strlen(input) + strlen(format);
    
    if (strcmp(output, "STDOUT") != 0) {
        len += strlen(output) + 10;
        cmd = (char *) malloc(len * sizeof(char));
        sprintf(cmd, "%s%s -%s %s >%s", sac, script, format, input, output);
    }
    else {
        len += 10;
        cmd = (char *)malloc(len * sizeof(char));
        sprintf(cmd, "%s%s -%s %s", sac, script, format, input);
    }

    getcwd(oldDir, MAX_PATH_LEN);
    chdir(tmpDir());
    system(cmd);
    chdir(oldDir);
    if (cmd) free(cmd);
}

extern void launchBarScript( char* input, char *output){
  launchBarScriptFormat( input, output, "png");
}


