/* $Id: gettime.c 1060 2007-11-13 15:56:35Z cg $ */

#include "RTClock.h"

void SAC_RTCLOCK_gettime( int *sec, int *nano)
{
  struct timespec *result = SAC_MALLOC( sizeof( struct timespec *));
  int error;

#ifdef _POSIX_CPUTIME
  error = clock_gettime( CLOCK_PROCESS_CPUTIME_ID, result);
#else
  error = clock_gettime( CLOCK_REALTIME, result);
#endif
  
  if (error != 0) {
    SAC_RuntimeError( "calling `clock_gettime' failed...");
  }

  *sec = (int) result->tv_sec;
  *nano = (int) result->tv_nsec;
}
  
